import javax.swing.*;
import javax.swing.border.Border;
import javax.swing.border.TitledBorder;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;
import java.awt.*;
import java.awt.event.*;
import java.math.BigDecimal;
import java.util.Arrays;
import java.util.Random;

/**
 * <b>Author:</b> Alex Krizhevsky<br>
 * <b>File Creation Date:</b> 15-Apr-2003<br>
 * <b>File Creation Time:</b> 4:02:06 PM<br>
 * <b>Description:</b> Demonstrates superposition of harmonic (sine) waves.<br><br>
 *
 * ---------------------------------------------<br>
 * <b>THIS CODE IS COPYRIGHT  ALEX KRIZHEVSKY (alien@sympatico.ca), 2003</b><br>
 * ---------------------------------------------<br>
 * <br>
 * The code is a bit messy, it certainly can be optimized in places, but anyway, here it is.
 */
public final class MainWave extends JApplet implements ActionListener, ChangeListener, MouseMotionListener, MouseListener {

    private final JPanel[] wavePanels = {new JPanel(null), new JPanel(null), new JPanel(null)};
    private final Graphics[] gr = new Graphics[3];
    private final Timer tmrShift = new Timer(30, this);
    private final JComponent[] jControls = {new JSpinner(new SpinnerNumberModel(25, 1, 25, 1)),
                                      new JSpinner(new SpinnerNumberModel(9, 1, 25, 1)),
                                      new JSpinner(new SpinnerNumberModel(33, 0, 40, 1)),
                                      new JSpinner(new SpinnerNumberModel(25, 0, 40, 1)),
                                      new JComboBox(new String[]{"0", "1", "2", "3", "4"}),
                                      new JComboBox(new String[]{"0", "1", "2", "3", "4"}),
                                      new JSpinner(new SpinnerNumberModel(30, 10, 100, 5))};

    private final JLabel[] lblLabels = {new JLabel("Frequency 1:"), new JLabel("Frequency 2:"), new JLabel("Amplitude 1:")
                                  , new JLabel("Amplitude 2:"), new JLabel("Speed 1:"), new JLabel("Speed 2:"), new JLabel("Timer Interval:")};
    private final JPanel pControls = new JPanel(null);
    private final JButton btnStopStart = new JButton("Stop");
    private final JButton btnRandomize = new JButton("Randomize");
    private final int mid = 50;
    private static final Font def_font = new Font("Dialog", Font.PLAIN, 11);
    private final int[] ticks = {-1, -1};
    private final int[] freq = new int[2];
    private final int[] ampl = new int[2];
    private DPoint last_pt = new DPoint(1, 0), last_pt_other = new DPoint(1, 0);
    private final Image[] img_offScreen = new Image[3];
    private final Graphics[] g_offScreen = new Graphics[3];
    private final int[] counted = new int[2];
    private final JCheckBox chkGraph = new JCheckBox("<html>Show graph<br>lines</html>", true);
    private DPoint pt = new DPoint(2, 0), other_pt = new DPoint(2, 0);
    private final JLabel[] lblTrace = {new JLabel(), new JLabel(), new JLabel()};
    private final Random rnd = new Random();
    private final String[] credits = {"Applet Copyright  Alex Krizhevsky", "alien@sympatico.ca"};
    private final JLabel lblAbout = new JLabel(credits[0]);
    private final Color[] waveColors = new Color[3];

    public MainWave() {
        getContentPane().setLayout(null);
        setSize(630, 500);
        for (int i = 0; i < wavePanels.length; i++) {
            wavePanels[i].setBounds(30, 30 + i * 2 * (mid + 15), getWidth() - 90, i == 2 ? (int) (mid * 3.5) : mid * 2);
            wavePanels[i].setBackground(Color.BLACK);
            getContentPane().add(wavePanels[i]);

            lblTrace[i].setBounds(getWidth() - 315 + i * 85, 10, 85, 20);
            lblTrace[i].setForeground(Color.WHITE);
            lblTrace[i].setHorizontalAlignment(SwingConstants.RIGHT);
            getContentPane().add(lblTrace[i]);
        };
        pControls.setBounds(wavePanels[0].getX() + 5 + wavePanels[0].getWidth(), wavePanels[0].getY() - 8,
                getWidth() - 527, 445);
        final Border linedBorder = BorderFactory.createLineBorder(Color.WHITE);
        pControls.setBorder(BorderFactory.createTitledBorder(linedBorder, "Controls"));
        ((TitledBorder) pControls.getBorder()).setTitleFont(new Font("Dialog", Font.PLAIN, 12));
        ((TitledBorder) pControls.getBorder()).setTitleColor(Color.WHITE);
        pControls.setBackground(Color.BLACK);
        chkGraph.setBounds(8, 340, pControls.getWidth() - 16, 38);

        lblAbout.setHorizontalAlignment(SwingConstants.RIGHT);
        lblAbout.setForeground(Color.LIGHT_GRAY);
        lblAbout.addMouseListener(this);
        getContentPane().add(lblAbout);
        btnRandomize.setBounds(8, pControls.getHeight() - 60, pControls.getWidth() - 16, 22);
        btnStopStart.setBounds(8, pControls.getHeight() - 30, pControls.getWidth() - 16, 22);
        chkGraph.setMargin(new Insets(0, 0, 0, 0));
        pControls.add(chkGraph);
        pControls.add(btnStopStart);
        for (int i = 0; i < lblLabels.length; i++) {
            if (jControls[i] instanceof JSpinner) {
                ((JSpinner) jControls[i]).addChangeListener(this);
            } else {
                ((JComboBox) jControls[i]).addActionListener(this);
                ((JComboBox) jControls[i]).setSelectedIndex(4);
            }
            jControls[i].setBounds(8, 35 + i * 46, pControls.getWidth() - 16, 22);
            pControls.add(jControls[i]);
            lblLabels[i].setBounds(8, 15 + i * 46, 70, 20);
            lblLabels[i].setForeground(Color.WHITE);
            pControls.add(lblLabels[i]);
        }

        getContentPane().add(pControls);
        btnStopStart.addActionListener(this);
        btnRandomize.addActionListener(this);
        chkGraph.addActionListener(this);
        getRootPane().setDefaultButton(btnStopStart);
        pControls.add(btnRandomize);
        addMouseListener(this);
        getContentPane().setBackground(Color.BLACK);
        changeFont(getContentPane());
    }

    private static void changeFont(final Container cont) {
        for (int i = 0; i < cont.getComponentCount(); i++) {
            if (cont.getComponent(i) instanceof Component) {
                cont.getComponent(i).setFont(def_font);
            }
            if (cont.getComponent(i) instanceof Container) {
                changeFont((Container) cont.getComponent(i));
            }
        }
    }

    private void randomizeWaves() {
        for (int i = 0; i < 4; i++) {
            final JSpinner spin = ((JSpinner) jControls[i]);
            if (i != 3)
                spin.removeChangeListener(this);
            final SpinnerNumberModel s_num = (SpinnerNumberModel) spin.getModel();
            spin.setValue(new Integer(getRndNum(Integer.parseInt(s_num.getMinimum().toString()),
                    Integer.parseInt(s_num.getMaximum().toString()))));
            if (i != 3)
                spin.addChangeListener(this);
        }
    }

    public void paint(final Graphics g) {
        super.paint(g);
        g.setColor(Color.WHITE);
        g.drawString("Note: When animation is stopped, right click for vertical trace line.", 5, getHeight() - 8);
        lblAbout.setBounds(getWidth() - 238, getHeight() - 23, 230, 20);
        g.setFont(g.getFont().deriveFont(12f));
        g.setColor(Color.WHITE);
        for (int i = 0; i < 3; i++) {
            final String msg = i < 2 ? "Wave " + String.valueOf((i + 1)) : "Wave 1 superposed on wave 2";
            final int pan_mid = i == 2 ? (int) (mid * 1.75) : mid;
            g.drawString(msg, wavePanels[i].getX(), wavePanels[i].getY() - 10);
            for (int j = pan_mid; j < wavePanels[i].getHeight(); j += 20) {
                g.drawString(String.valueOf(j - pan_mid), 6, wavePanels[i].getY() + wavePanels[i].getHeight() - j + 5);
                if (j != pan_mid) {
                    g.drawString(String.valueOf(pan_mid - j), 6, wavePanels[i].getY() + j + 5);
                }
            }
        }
        if (!tmrShift.isRunning() || Integer.parseInt(((JComboBox) jControls[4]).getSelectedItem().toString()) == 0 ||
                Integer.parseInt(((JComboBox) jControls[5]).getSelectedItem().toString()) == 0) {
            redrawWaves(true, true);
        }
    }

    private int getRndNum(final int min, final int max) {
        return rnd.nextInt(max - min + 1) + min;
    }

    public void init() {
        updateFreqAmpl();
        for (int i = 0; i < 3; i++) {
            try {
                final String[] cols = getParameter("wave" + i).split(",");
                waveColors[i] = new Color(Integer.parseInt(cols[0]), Integer.parseInt(cols[1]), Integer.parseInt(cols[2]));
            } catch (Exception e) {
                waveColors[i] = i == 0 ? Color.GREEN : i == 1 ? Color.RED : Color.ORANGE;
            }
            img_offScreen[i] = wavePanels[i].createImage(wavePanels[i].getWidth(), wavePanels[i].getHeight());
            g_offScreen[i] = img_offScreen[i].getGraphics();
            gr[i] = wavePanels[i].getGraphics();
        }
        randomizeWaves();
        tmrShift.start();
    }

    private void updateFreqAmpl() {
        for (int i = 0; i < 2; i++) {
            freq[i] = Integer.parseInt(((JSpinner) jControls[i]).getValue().toString());
            ampl[i] = Integer.parseInt(((JSpinner) jControls[i + 2]).getValue().toString());
        }
    }

    private void drawGraph(final int pan) {
        final int pan_mid = pan == 2 ? rnd(mid * 1.75) : mid;
        for (int i = pan_mid, y = pan_mid; i < wavePanels[pan].getHeight(); i += 20, y -= 20) {
            g_offScreen[pan].setColor(Color.LIGHT_GRAY.darker());
            if (i != 0 && i != wavePanels[pan].getHeight()) {
                g_offScreen[pan].drawLine(1, y, wavePanels[pan].getWidth() - 2, y);
                if (i != pan_mid) {
                    g_offScreen[pan].drawLine(1, i, wavePanels[pan].getWidth() - 2, i);
                }
            }
        }
    }

    private void redrawWaves(final boolean repainting, final boolean draw) {
        final int[] speed = {Integer.parseInt(((JComboBox) jControls[4]).getSelectedItem().toString()),
                       Integer.parseInt(((JComboBox) jControls[5]).getSelectedItem().toString())};
        final boolean[] updateNow = new boolean[2];
        updateFreqAmpl();

        for (int i = 0; i < 2; i++) {
            updateNow[i] = speed[i] == 4 || speed[i] == 3 && counted[i] != 3 || speed[i] == 2 && counted[i] % 2 == 0 ||
                    speed[i] == 1 && counted[i] == 1;
            if (updateNow[i] && !repainting) {
                if (ticks[i] == 360 * freq[i])
                    ticks[i] = 0;
                ticks[i]++;
            }
            if (speed[i] != 0 && !repainting)
                counted[i] = counted[i] < 4 ? counted[i] + 1 : 1;
        }

        for (int i = 0; i < wavePanels.length; i++) {
            if (!(i < 2 && !updateNow[i]) || repainting) {
                g_offScreen[i].setColor(Color.BLACK);
                g_offScreen[i].fillRect(1, 1, wavePanels[i].getWidth() - 2, wavePanels[i].getHeight() - 2);
                if (chkGraph.isSelected())
                    drawGraph(i);
            }
            g_offScreen[i].setColor(waveColors[i]);
        }

        for (int i = 1; i < wavePanels[0].getWidth() - 1; i++) {
            pt = calcPoint(i, 0);
            other_pt = calcPoint(i, 1);
            if (i != 1) {
                if (updateNow[0] || repainting) {
                    g_offScreen[0].drawLine(last_pt.x, rnd(mid - last_pt.y), pt.x, rnd(mid - pt.y));
                }
                if (updateNow[1] || repainting) {
                    g_offScreen[1].drawLine(last_pt_other.x, rnd(mid - last_pt_other.y), other_pt.x, rnd(mid - other_pt.y));
                }
                final DPoint pt1 = new DPoint(last_pt.x, last_pt.y + last_pt_other.y);
                final DPoint pt2 = new DPoint(pt.x, pt.y + other_pt.y);
                g_offScreen[2].drawLine(pt1.x, rnd(mid * 1.75) - rnd(pt1.y), pt2.x, rnd(mid * 1.75) - rnd(pt2.y));
            }
            last_pt = pt;
            last_pt_other = other_pt;
        }

        if (draw) {
            for (int i = 0; i < 3; i++) {
                if (!(i < 2 && !updateNow[i]) || repainting)
                    gr[i].drawImage(img_offScreen[i], 0, 0, wavePanels[i].getWidth(), wavePanels[i].getHeight(), wavePanels[i]);
            }
        }
    }

    private DPoint calcPoint(final int x, final int wave) {
        final double y = (double) ampl[wave] * Math.sin((double) freq[wave] * Math.toRadians((double) ((wave == 0 ?
                -ticks[0] : ticks[1]) + x - 1)));
        return new DPoint(x, y);
    }

    public void actionPerformed(final ActionEvent e) {
        if (e.getSource() == btnStopStart) {
            if (btnStopStart.getText().equals("Stop"))
                tmrShift.stop();
            else {
                clearTrace();
                removeMouseMotionListener(this);
                tmrShift.start();
            }
            btnStopStart.setText(!tmrShift.isRunning() ? "Start" : "Stop");
        } else if (e.getSource() == chkGraph && (!tmrShift.isRunning() || Integer.parseInt(((JComboBox) jControls[4]).
                getSelectedItem().toString()) == 0 || Integer.parseInt(((JComboBox) jControls[5]).getSelectedItem().
                toString()) == 0)) {
            redrawWaves(true, true);
        } else if (e.getSource() == btnRandomize) {
            randomizeWaves();
        } else if (e.getSource() == ((JComboBox) jControls[4]) || e.getSource() == ((JComboBox) jControls[5])) {
            final int src = e.getSource() == ((JComboBox) jControls[4]) ? 0 : 1;
            counted[src] = counted[src == 0 ? 1 : 0];
        } else if (e.getSource() == tmrShift) {
            redrawWaves(false, true);
        }
    }

    public void stateChanged(final ChangeEvent e) {
        if (e.getSource() == jControls[6])
            tmrShift.setDelay(Integer.parseInt(((JSpinner) jControls[6]).getValue().toString()));
        else {
            ticks[0] = -1;
            ticks[1] = -1;
            last_pt_other = new DPoint(1, 0);
            last_pt = new DPoint(1, 0);
            if (Integer.parseInt(((JComboBox) jControls[4]).getSelectedItem().toString()) == 0 ||
                    Integer.parseInt(((JComboBox) jControls[5]).getSelectedItem().toString()) == 0 || !tmrShift.isRunning()) {
                ticks[0] = 0;
                ticks[1] = 0;
                redrawWaves(true, true);
            }
        }
    }

    private void drawVerticalLine(final int x) {
        redrawWaves(true, false);
        final int drawX = 1 + (x < wavePanels[0].getX() ? 0 : x >= wavePanels[0].getX() +
                wavePanels[0].getWidth() - 2 ? wavePanels[0].getWidth() - 3 : x - wavePanels[0].getX());
        BigDecimal b;
        final double[] y = new double[3];
        for (int i = 0; i < 3; i++) {
            b = new BigDecimal(i < 2 ? calcPoint(drawX, i).y : y[0] + y[1]).setScale(2, BigDecimal.ROUND_HALF_UP);
            y[i] = b.doubleValue();
            g_offScreen[i].setColor(Color.WHITE);
            g_offScreen[i].drawLine(drawX, 0, drawX, wavePanels[i].getHeight());
            gr[i].drawImage(img_offScreen[i], 0, 0, wavePanels[i].getWidth(), wavePanels[i].getHeight(), wavePanels[i]);
        }

        lblTrace[0].setText("y1=" + y[0]);
        lblTrace[1].setText("y2=" + y[1]);
        lblTrace[2].setText("y1+y2=" + y[2]);
    }

    private void clearTrace() {
        for (int i = 0; i < 3; i++)
            lblTrace[i].setText("");
    }

    public void mouseMoved(final MouseEvent e) {
        if (!tmrShift.isRunning()) {
            drawVerticalLine(e.getX());
        }
    }

    public void mouseDragged(final MouseEvent e) {
    }

    public void mouseClicked(final MouseEvent e) {
    }

    public void mousePressed(final MouseEvent e) {
        if (e.getSource() == this && e.getButton() == MouseEvent.BUTTON3 && !tmrShift.isRunning()) {
            if (Arrays.asList(getMouseMotionListeners()).contains(this)) {
                clearTrace();
                removeMouseMotionListener(this);
                redrawWaves(true, true);
            } else {
                addMouseMotionListener(this);
                drawVerticalLine(e.getX());
            }
        }
    }

    private static int rnd(final double r) {
        return (int) Math.round(r);
    }

    public void mouseReleased(final MouseEvent e) {
    }

    public void mouseEntered(final MouseEvent e) {
        if (e.getSource() == lblAbout)
            lblAbout.setText(credits[1]);
    }

    public void mouseExited(final MouseEvent e) {
        if (e.getSource() == lblAbout)
            lblAbout.setText(credits[0]);
    }
}

final class DPoint {
    final int x;
    final double y;

    public DPoint(final int x, final double y) {
        this.x = x;
        this.y = y;
    }
}